//
// ʏoWJ
//
// written by T.Noda
//
// 2001/06/06 Ver 0.0.0 R[fBOJn
// 2001/06/19 Ver 0.0.1 Jn
// 2001/06/25 Ver 0.0.2 ̉ɏosC
// 2001/06/28 Ver 0.0.3 GfBbg{bNX̃TCYύX
// FΐSʂɑΉ̗\
//
//*********************************
//
//  vZ
//
//*********************************
function  MinusGet(thickness : double; angle : double) : double;
var
  mt, mx1, my1, mx2, my2, mx3, my3, mxm1, mym1, mxm2, mym2, malpha, mbeta, ma, mb, mc, md, mx0, my0, mr : double;

begin
  if angle > 90.0 then 
  begin
    angle := 180.0-angle;
  end;
  case thickness of // ɑ΂XÖ̐ݒ
  0.5 : mt := 0.8;
  0.8 : mt := 1.5;
  1.0 : mt := 1.8;
  1.2 : mt := 2.0;
  1.5 : mt := 2.8;
  1.6 : mt := 2.5;
  2.0 : mt := 3.8;
  2.3 : mt := 3.8;
  2.5 : mt := 4.5;
  2.6 : mt := 4.2;
  3.0 : mt := 5.2;
  3.2 : mt := 5.0;
  4.0 : mt := 7.0;
  4.5 : mt := 7.5;
  5.0 : mt := 8.5;
  6.0 : mt := 10.0;
  8.0 : mt := 15.0;
  9.0 : mt := 15.0;
  10.0 : mt := 16.0;
  12.0 : mt := 18.0;
  14.0 : mt := 22.0;
  16.0 : mt := 24.0;
  else mt := 0.0;
  end;

  mx1 := 0.0;
  my1 := 0.0;
  mx3 := 90.0;
  my3 := mt;
  mx2 := 45.0;
  my2 := mt/3.0;
  mxm1 := mx1+(mx2-mx1)*0.5;
  mym1 := my1+(my2-my1)*0.5;
  mxm2 := mx2+(mx3-mx2)*0.5;
  mym2 := my2+(my3-my2)*0.5;
  malpha := arctan((my2-my1)/(mx2-mx1))+90.0;
  mbeta := arctan((my3-my2)/(mx3-mx2))+90.0;
  ma := tan(malpha);
  mb := mym1-ma*mxm1;
  mc := tan(mbeta);
  md := mym2-mc*mxm2;
  mx0 := (md-mb)/(ma-mc);
  my0 := ma*mx0+mb;
  mr := sqrt((mx1-mx0)*(mx1-mx0)+(my1-my0)*(my1-my0));
  ma := 1.0;
  mb := -2.0*my0;
  mc := my0*my0+(angle-mx0)*(angle-mx0)-mr*mr;
  mt := (-mb-sqrt(mb*mb-4.0*ma*mc))/(2.0*ma);
  mt := 10.0*mt;
  mt := Round(mt);
  Result := 0.1*mt;
end;
//*********************************
//
//  CvO
//
//*********************************
Program Mendashi;
var
  leng, ang, thick, width, wid_old, dist, minus, a, b, c, d, x, y, xm, ym, x1, y1, x2, y2, x3, y3, x4, y4, x5, y5, x6, y6 : double;
  ID, i : Integer;
  Check : Boolean;

Begin

  leng := 10.0;
  ang := 90.0;
  thick := 1.6;
  Check := true;
  while true do
  begin
    AddImage(20, 20, 'MEN_PARAM.BMP');
    AddLabel(150, 22, 75, 13, 'ʏo(L)');
    AddLabel(150, 52, 75, 13, 'Ȃpx(A)');
    AddLabel(150, 82, 75, 13, '(t)');
    AddLabel(150, 112, 95, 13, '␳');

    AddEdit(1, 220, 20, 60, 21, FloatToStr(leng));
    AddEdit(2, 230, 50, 50, 21, FloatToStr(ang));
    AddEdit(3, 230, 80, 50, 21, FloatToStr(thick)); 

    AddCheckBox(1, 210, 110, false, ''); // `FbN{bNX
    AddCheckBox(2, 250, 110, false, 'E'); // `FbN{bNX

    If ShowDlg(300, 180,'ʏoWJ_CAO') <> True Then
      Exit;

    leng := StrToFloat(GetDlgText(1)); // ɕϊ
    ang := StrToFloat(GetDlgText(2));
    thick := StrToFloat(GetDlgText(3));

    Message('ʏovfIĉB');
    ID := GetLineInfo(x1, y1, x2, y2);
    if ID = -1 then
    begin
      exit;
    end;
    AddImage(20, 20, 'MEN_PARAM.BMP');

    a := PosToAngl(x1, y1, x2, y2);
    width := Distance(x1, y1, x2, y2);
    if CheckBoxChecked(1) then
    begin
      width := width-thick;
      x1 := x1+thick*cos(a);
      y1 := y1+thick*sin(a);
    end;
    if CheckBoxChecked(2) then
    begin
      width := width-thick;
      x2 := x2-thick*cos(a);
      y2 := y2-thick*sin(a);
    end;
    dist := 0.0;
    minus := MinusGet(thick, ang);
    wid_old := width;
    AddLabel(150, 22, 75, 13, 'ʕ(W)');
    AddLabel(150, 52, 75, 13, 'ΐS(D)   ');
    AddLabel(150, 82, 75, 13, '(M)');

    AddEdit(1, 220, 20, 60, 21, FloatToStr(width));
    AddEdit(2, 230, 50, 50, 21, FloatToStr(dist));
    AddEdit(3, 230, 80, 50, 21, FloatToStr(-minus));

    If ShowDlg(300, 180,'ʏoWJ_CAO') <> True Then
      Exit;

    width := StrToFloat(GetDlgText(1)); // ɕϊ
    dist := StrToFloat(GetDlgText(2));
    minus := -StrToFloat(GetDlgText(3));

    Check := true;
    Message('ʏo͂ĉB');
    GetPos(xm, ym);
    b := PosToAngl(x1, y1, xm, ym);
    if (a < 90.0) AND (b > 270.0) then
    begin
      b := b-360.0;
    end;
    if a < b then
    begin
      c := a+90.0;
      d := a-90.0;
    end
    else
    begin
      c := a-90.0;
      d := a+90.0;
    end;
    x3 := x1+(leng-minus)*cos(c);
    y3 := y1+(leng-minus)*sin(c);
    x4 := x3+width*cos(a);
    y4 := y3+width*sin(a);
    x5 := x1+minus*cos(d);
    y5 := y1+minus*sin(d);
    x6 := x5+width*cos(a);
    y6 := y5+width*sin(a);
//    Erase(ID);
    PenNo(1); // yԍ
    LineType(2); // j
    Line(x5, y5, x6, y6);
    LineType(0); // 
    Line(x5, y5, x3, y3);
    Line(x3, y3, x4, y4);
    Line(x4, y4, x6, y6);
  end;
End.
